#include "DLDocID.h"
#include "DLImage.h"
#include "DLBitsPerPixelConverter.h"

int main(int argc, char *argv[])
{
	if( argc > 5 )
	{
		cout << "DLDocID [filename]" << endl;
		cout << "   If [filename] is not provided, three images in the data folder will be processed." << endl;
	}
	else if(argc == 4)
	{

	}
	else if( argc == 3 )
	{
		string imginputfilename = argv[1];
		string edgefilename = imginputfilename + "_edge.png";
		string txtoutputfilename = imginputfilename + "_output_line.txt";

		DLImage im;
		im.dlLoadImage(imginputfilename.c_str());

		if( im.dlGetDepth() == DL_BITDEPTH_24 )
			im = DLBitsPerPixelConverter::dlDownscaleColor2Gray_global(im);
		else if( im.dlGetDepth() == DL_BITDEPTH_1 )
			im = DLBitsPerPixelConverter::dlBinary2Gray(im);

		DLDocID docID;
		docID.getHistogram( im.dlResizeImage( atoi(argv[2]), atoi(argv[2]) ) );
		docID.saveHist(txtoutputfilename);	
	}
	else
	{
		for(int i = 1; i<201; i++)
		{
			char tmp[5];
			sprintf(tmp,"%d",i);

			string imginputfilename = "..\\..\\data_singapore_256\\image_";
			imginputfilename+=tmp;
			imginputfilename+=".jpg";

			string edgefilename = imginputfilename + "_edge.png";
			string txtoutputfilename = imginputfilename + "_output_line.txt";
	
			DLImage im;
			im.dlLoadImage(imginputfilename.c_str());

			if( im.dlGetDepth() == DL_BITDEPTH_24 )
				im = DLBitsPerPixelConverter::dlDownscaleColor2Gray_global(im);
			else if( im.dlGetDepth() == DL_BITDEPTH_1 )
				im = DLBitsPerPixelConverter::dlBinary2Gray(im);

			DLDocID docID;
			docID.getHistogram( im.dlResizeImage( atoi(argv[1]), atoi(argv[1]) ) );
			docID.saveHist(txtoutputfilename);	
		}
	}
	return 1;
}
